untrusted comment: verify with openbsd-71-base.pub
RWR2eHwZTOEiTfhkdd2m1IScTRS2i92ja3unHrN5cZ33atiFDiM5X3qFTFO4dqL6w7GwgZtSJvAeiv1Jp3sPUI/nnvRULjTGvgk=

OpenBSD 7.1 errata 004, May 16, 2022:

libcrypto would incorrectly decode certain ASN.1 objects.

Apply by doing:
    signify -Vep /etc/signify/openbsd-71-base.pub -x 004_asn1.patch.sig \
        -m - | (cd /usr/src && patch -p0)

And then rebuild and install libcrypto and unwind:
    cd /usr/src/lib/libcrypto
    make obj
    make includes
    make
    make install
    cd /usr/src/sbin/unwind
    make obj
    make
    make install

Index: lib/libcrypto/asn1/a_object.c
===================================================================
RCS file: /cvs/src/lib/libcrypto/asn1/a_object.c,v
diff -u -p -r1.46 a_object.c
--- lib/libcrypto/asn1/a_object.c	10 Apr 2022 12:42:33 -0000	1.46
+++ lib/libcrypto/asn1/a_object.c	13 May 2022 16:09:45 -0000
@@ -651,7 +651,7 @@ d2i_ASN1_OBJECT(ASN1_OBJECT **out_aobj, 
 	if (!c2i_ASN1_OBJECT_cbs(&aobj, &content))
 		return NULL;
 
-	*pp = CBS_data(&content);
+	*pp = CBS_data(&cbs);
 
 	if (out_aobj != NULL)
 		*out_aobj = aobj;
